import random


class Animal:

    def __init__(self, age):
        self.age = age
        self.name = None

    def get_age(self):
        return self.age

    def get_name(self):
        return self.name

    def set_age(self, new_age):
        self.age = new_age

    def set_name(self, new_name=""):
        self.name = new_name

    def __str__(self):
        return "animal: " + str(self.name) + ":" + str(self.age)

    def hello(self):
        print('Hello')


class Cat(Animal):
    def speak(self):
        print('Meow')

    def __str__(self):
        return "cat:" + str(self.name) + ":" + str(self.age)

    def hello(self):
        print('World')


class Person(Animal):

    def __init__(self, name, age):
        Animal.__init__(self, age)
        self.set_name(name)
        self.friends = []

    def get_friends(self):
        return self.friends

    def add_friend(self, fname):
        if fname not in self.friends:
            self.friends.append(fname)

    def speak(self):
        print('Hello')

    def age_diff(self, other):
        return abs(self.age - other.age)

    def __str__(self):
        return "person:" + str(self.name) + ":" + str(self.age)


class Student(Person):

    def __init__(self, name, age, major=None, class_id=None):
        Person.__init__(self, name, age)
        self.major = major
        self.id = class_id

    def change_major(self, new_major):
        self.major = new_major

    def speak(self):
        r = random.random()
        if r < 0.25:
            print("I have homework")
        elif 0.25 <= r < 0.5:
            print("I need sleep")
        elif 0.5 <= r < 0.75:
            print("I should eat")
        else:
            print('I am watching Netflix')

    def __str__(self):
        return "student:" + str(self.name) + ":" + str(self.age) +\
            " " + str(self.major)

    def set_id(self, class_id):
        self.id = class_id

    def get_id(self):
        return self.id



class JHU_Course:
    tag = 0

    def __init__(self, name=None, dept=None):
        self.name = name
        self.dept = dept
        self.id = 0
        self.students = []

    def register(self, student):
        # JHU_Course.tag += 1
        self.id += 1
        student.set_id(self.id)
        self.students.append(student)

    def get_roster(self):
        for student in self.students:
            print(student)


if __name__ == '__main__':
    # animal1 = Animal(1)
    # animal2 = Animal(2)
    # animal1.set_name('Bob')
    # animal2.set_name('Harry')
    # print(animal1.get_name())
    # animal1.hello()
    # cat1 = Cat('Fifa')
    # print(cat1)
    # cat1.hello()
    # cat1.speak()
    # divya = Person('Divya', 25)
    # isaiah = Person('Isaiah', 23)
    # # print(divya.age_diff(isaiah))
    # print(divya)

    soft_car = JHU_Course('Software Carpentry', 'ChemBE')
    # print(soft_car.name, soft_car.dept)
    atp = JHU_Course('Advanced Transport Phenomena', 'ChemBE')
    # print(atp.name, atp.dept)
    divya = Student('Divya', 25)
    isaiah = Student('Isaiah', 25)
    soft_car.register(divya)
    atp.register(isaiah)
    print(divya.get_id())
    print(isaiah.get_id())
    # print(soft_car.get_roster())